%global srcname JCTools

Summary:        Java Concurrency Tools for the JVM
Name:           jctools
Version:        3.3.0
Release:        4%{?dist}
License:        ASL 2.0

URL:            https://github.com/JCTools/JCTools
Source0:        %{url}/archive/v%{version}/%{srcname}-%{version}.tar.gz

BuildArch:      noarch
ExclusiveArch:  %{java_arches} noarch

BuildRequires: mvn(org.hamcrest:hamcrest-all)
BuildRequires: maven-local-openjdk8 mvn(com.google.guava:guava-testlib) mvn(junit:junit) mvn(org.apache.felix:maven-bundle-plugin)

%description
Java Concurrency Tools for the JVM.
This project aims to offer some concurrent data structures
currently missing from the JDK:

° SPSC/MPSC/SPMC/MPMC Bounded lock free queues
° SPSC/MPSC Unbounded lock free queues
° Alternative interfaces for queues
° Offheap concurrent ring buffer for ITC/IPC purposes
° Single Writer Map/Set implementations
° Low contention stats counters
° Executor


%package javadoc
Summary:        Javadoc for %{name}

%description javadoc
This package provides docs for %{name}.


%prep
%autosetup -n %{srcname}-%{version}

rm jctools-core/src/test/java/org/jctools/queues/MpqSanityTestMpscCompound.java
rm jctools-core/src/test/java/org/jctools/queues/atomic/AtomicMpqSanityTestMpscCompound.java
rm jctools-core/src/test/java/org/jctools/maps/NonBlockingHashMapTest.java

%pom_xpath_set pom:project/pom:version %{version}
%pom_xpath_set pom:parent/pom:version %{version} jctools-{build,core,channels,experimental}

%pom_remove_plugin :coveralls-maven-plugin jctools-core
%pom_remove_plugin :jacoco-maven-plugin jctools-core
%pom_remove_plugin :maven-enforcer-plugin
%pom_remove_plugin :maven-source-plugin jctools-core
%pom_remove_plugin :maven-javadoc-plugin jctools-core

%pom_remove_dep org.jetbrains.kotlinx:lincheck jctools-core
rm -r jctools-core/src/test/java/org/jctools/maps/linearizability_test/

%pom_disable_module jctools-benchmarks
%pom_disable_module jctools-concurrency-test

%pom_disable_module jctools-channels
%pom_disable_module jctools-experimental
%pom_disable_module jctools-build
%pom_remove_plugin :exec-maven-plugin jctools-core

%mvn_package :jctools-build __noinstall
%mvn_package :jctools-parent __noinstall


%build
%mvn_build -s -f


%install
%mvn_install


%files -f .mfiles-jctools-core
%doc README.md
%license LICENSE

%files javadoc -f .mfiles-javadoc
%license LICENSE


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.0-4
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.0-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.3.0-2
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 25 2023 cunshunxia <cunshunxia@tencent.com> - 3.3.0-1
- initial build
